#!/bin/gnuplot
set term post landscape size 29cm,21cm color enhanced
set output "cBreakdown.ps"

set title "Clustering execution time breakdown, n_{sample}=10000, n_{class}=10, n_{MoG iteration}=100"
set colorsequence podo;
set style data histograms
set style histogram rowstacked
set style fill solid 0.25 border
set boxwidth .5
set key autotitle columnheader
set xtics rotate by 315
set xlabel "Implementation"
#set ylabel "Fraction of implementation-wise benchmark runtime"
set ylabel "Runtime (s)"

plot '../../share/profiling_clustering/20160528_143931_breakdown.dat' using 2:xtic(1) title column(2), for [i=3:5] '' using (column(i)) title column(i);
