#!/bin/gnuplot
set term post landscape size 14.8cm,21cm color enhanced
set output "cMemoryBytes.ps"

set title "Total memory transfer, n_s = 10000, n_c = 10, n_i = 100"
set colorsequence podo;
set style data histograms
set style histogram rowstacked
set style fill solid 0.25 border
set boxwidth .5
set key autotitle columnheader
set xtics rotate by 315
set xlabel "Implementation"
set ylabel "Transfer amount (GB)"
set key left;

plot '../../share/profiling_clustering/20160530_172603_memory_bytes.dat' using ($2/1e9):xtic(1) title column(2), for [i=3:4] '' using (column(i)/1e9) title column(i);
