#!/bin/gnuplot
set term post landscape size 29.7cm,21cm color enhanced
set output "cSubsample.ps"
set multiplot;

set title "Clustering performance";
set colorsequence podo;
set linetype cycle 32;
set xrange [0:*];
set ylabel "Runtime (s)";

set tmargin at screen 0.95;
set bmargin at screen 0.25;
set lmargin at screen 0.10;
set key left top;
unset xtics;
plot\
		"../../share/benchmark_clustering/20160531_230806_worker_af_cuda" using (2000*1500/$1):2:4:5 with errorlines title "ArrayFire CUDA",\
		"../../share/benchmark_clustering/20160531_230806_worker_af.py" using (2000*1500/$1):2:4:5 with errorlines title "ArrayFire Python",\
		"../../share/benchmark_clustering/20160531_230806_worker_static" using (2000*1500/$1):2:4:5 with errorlines title "CUDA",\
		"../../share/benchmark_clustering/20160531_230806_worker_matlab.sh" using (2000*1500/$1):2:4:5 with errorlines title "MATLAB",\
		"../../share/benchmark_clustering/20160531_230806_worker_matlab_cpu.sh" using (2000*1500/$1):2:4:5 with errorlines title "MATLAB (16 CPU cores)",\
		"../../share/benchmark_clustering/20160531_230806_worker_static_cublas" using (2000*1500/$1):2:4:5 with errorlines title "CUDA cuBLAS",\
		"../../share/benchmark_clustering/20160531_230806_worker_dynamic" using (2000*1500/$1):2:4:5 with errorlines title "CUDA RAII",\
		"../../share/benchmark_clustering/20160531_230806_worker_af_cuda_oscore" using (2000*1500/$1):2:4:5 with errorlines title "ArrayFire score",\
		"../../share/benchmark_clustering/20160531_230806_worker_af_cuda_omogem" using (2000*1500/$1):2:4:5 with errorlines title "ArrayFire MoGEM";

unset title;
set label 1 center at graph .5,0.9 "Relative workload estimate";
set tmargin at screen 0.25;
set bmargin at screen 0.10;
set ylabel "sum@^{n_{class}}_{i=1}   (i*n_{MoG iterations})"
set xlabel "n_{sample}";
set ytics 0,2000,1e4;
set xtics;
set key off;
plot\
		"../../share/benchmark_clustering/20160531_230806_worker_af_cuda" using (2000*1500/$1):6 with linespoints title "ArrayFire CUDA",\
		"../../share/benchmark_clustering/20160531_230806_worker_af.py" using (2000*1500/$1):6 with linespoints title "ArrayFire Python",\
		"../../share/benchmark_clustering/20160531_230806_worker_static" using (2000*1500/$1):6 with linespoints title "CUDA",\
		"../../share/benchmark_clustering/20160531_230806_worker_matlab.sh" using (2000*1500/$1):6 with linespoints title "MATLAB",\
		"../../share/benchmark_clustering/20160531_230806_worker_matlab_cpu.sh" using (2000*1500/$1):6 with linespoints title "MATLAB (16 CPU cores)",\
		"../../share/benchmark_clustering/20160531_230806_worker_static_cublas" using (2000*1500/$1):6 with linespoints title "CUDA cuBLAS",\
		"../../share/benchmark_clustering/20160531_230806_worker_dynamic" using (2000*1500/$1):6 with linespoints title "CUDA RAII",\
		"../../share/benchmark_clustering/20160531_230806_worker_af_cuda_oscore" using (2000*1500/$1):6 with linespoints title "CUDA cuBLAS",\
		"../../share/benchmark_clustering/20160531_230806_worker_af_cuda_omogem" using (2000*1500/$1):6 with linespoints title "CUDA RAII";
