#!/bin/gnuplot
set term post landscape size 29.7cm,21cm color enhanced
set output "cSubsampleFixedWorkload.ps"
set multiplot;

set title "Clustering performance with fixed relative workload: n_{class} = 10, n_{MoG iteration} = 100";
set colorsequence podo;
set linetype cycle 32;
set xrange [0:*];
set ylabel "Runtime (s)";
set xlabel "n_{sample}";
set key left top;
plot\
		"../../share/benchmark_clustering/20160531_144401_worker_af_cuda" using (2000*1500/$1):2:4:5 with errorlines title "ArrayFire CUDA",\
		"../../share/benchmark_clustering/20160531_144401_worker_af.py" using (2000*1500/$1):2:4:5 with errorlines title "ArrayFire Python",\
		"../../share/benchmark_clustering/20160531_144401_worker_static" using (2000*1500/$1):2:4:5 with errorlines title "CUDA",\
		"../../share/benchmark_clustering/20160531_144401_worker_matlab.sh" using (2000*1500/$1):2:4:5 with errorlines title "MATLAB",\
		"../../share/benchmark_clustering/20160531_144401_worker_matlab_cpu.sh" using (2000*1500/$1):2:4:5 with errorlines title "MATLAB (16 CPU cores)",\
		"../../share/benchmark_clustering/20160531_144401_worker_static_cublas" using (2000*1500/$1):2:4:5 with errorlines title "CUDA cuBLAS",\
		"../../share/benchmark_clustering/20160531_144401_worker_dynamic" using (2000*1500/$1):2:4:5 with errorlines title "CUDA RAII",\
		"../../share/benchmark_clustering/20160531_144401_worker_af_cuda_oscore" using (2000*1500/$1):2:4:5 with errorlines title "ArrayFire CUDA score",\
		"../../share/benchmark_clustering/20160531_144401_worker_af_cuda_omogem" using (2000*1500/$1):2:4:5 with errorlines title "ArrayFire CUDA MoGEM";
