#!/bin/gnuplot
set term post landscape size 14.8cm,21cm color enhanced
set output "spWindow.ps"
set multiplot

set title "Streaming pipeline performance, n_{column per block} = 300";
set colorsequence podo;
set linetype cycle 32;
set arrow from 25,graph 0 to 25,graph 1 nohead linetype 0;
set xrange [0:*];
set ylabel "Runtime (s)";

set label 1 center at graph .5,0.9 "Full range"
set tmargin at screen 0.95;
set bmargin at screen 0.75;
set lmargin at screen 0.15;
set ytics 20,40,200;
set yrange [0:*];
unset xtics;
set key off;
plot\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_af_cuda" using 1:3:5:6 with errorlines title "ArrayFire CUDA",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_af.py" using 1:3:5:6 with errorlines title "ArrayFire Python",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_cuda" using 1:3:5:6 with errorlines title "CUDA",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_matlab.sh" using 1:3:5:6 with errorlines title "MATLAB",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_matlab_cpu.sh" using 1:3:5:6 with errorlines title "MATLAB (CPU 16 cores)",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_cuda.py" using 1:3:5:6 with errorlines title "PyCUDA",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_openacc" using 1:3:5:6 with errorlines title "OpenACC",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_thrust" using 1:3:5:6 with errorlines title "Thrust",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_vexcl_cuda" using 1:3:5:6 with errorlines title "VexCL CUDA",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_vexcl_cl" using 1:3:5:6 with errorlines title "VexCL OpenCL",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_af_cl" using 1:3:5:6 with errorlines title "ArrayFire OpenCL",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_openmp" using 1:3:5:6 with errorlines title "OpenMP (CPU 16 cores)";

unset title;
set xlabel "l_{window size} = l_x = l_y";
set label 1 center at graph .5,0.95 "Zoomed"
set key right bottom;
set tmargin at screen 0.75;
set bmargin at screen 0.10;
set ytics auto;
set xtics;#1e6,3e6,1e8
set yrange [0:25];
plot\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_af_cuda" using 1:3:5:6 with errorlines title "ArrayFire CUDA",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_af.py" using 1:3:5:6 with errorlines title "ArrayFire Python",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_cuda" using 1:3:5:6 with errorlines title "CUDA",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_matlab.sh" using 1:3:5:6 with errorlines title "MATLAB",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_matlab_cpu.sh" using 1:3:5:6 with errorlines title "MATLAB (CPU 16 cores)",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_cuda.py" using 1:3:5:6 with errorlines title "PyCUDA",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_openacc" using 1:3:5:6 with errorlines title "OpenACC",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_thrust" using 1:3:5:6 with errorlines title "Thrust",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_vexcl_cuda" using 1:3:5:6 with errorlines title "VexCL CUDA",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_vexcl_cl" using 1:3:5:6 with errorlines title "VexCL OpenCL",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_af_cl" using 1:3:5:6 with errorlines title "ArrayFire OpenCL",\
		"../../share/benchmark_streaming_pipeline/20160528_195138_worker_openmp" using 1:3:5:6 with errorlines title "OpenMP (CPU 16 cores)";
