function [] = AMoG(feature_fns)
	tic;

	nfeature = numel(feature_fns);
	[type, dims] = cmxExtract(feature_fns{1});
	nsample = prod(dims);

	samples = readInput(feature_fns, nfeature, nsample);

	tAMoG = toc;
    o = Optimizer;
	o = o.split_until_all_classes_within_confidence_interval(samples);
	fprintf('%-10s %10.6f %10.6f\n', 'AMOG', tAMoG, toc);

    cmxWrite('classifier_P', gather(o.P), 'float32');
    cmxWrite('classifier_mu', gather(o.mu), 'float32');
    cmxWrite('classifier_Sigma', gather(o.Sigma), 'float32');
end

function [samples] = readInput(feature_fns, nfeature, nsample)
    C = config();
	samples = zeros(nfeature,ceil(nsample/C.SUBSAMPLE), 'gpuArray');
	for i = 1:nfeature
		fp = fopen(feature_fns{i}, 'r');
        all_samples = fread(fp, nsample, 'float32');
		samples(i,:) = all_samples(1:C.SUBSAMPLE:nsample);
		fclose(fp);
	end
end
