#pragma once

#include "CudaMoGEM.hpp"
#include <arrayfire.h>

class CudaMoGEMAfBindings: public CudaMoGEM {
public:
	CudaMoGEMAfBindings(dim_t nfeature, dim_t nsample, dim_t nclass);

	void af_cov_rowwise(af::array& Sigma, const af::array& samples, const af::array& mu);
	void print_gm(const af::array& P, const af::array& mu, const af::array& Sigma) const;
	void pdfs_from_samples(af::array& pdfs, const af::array& samples, const af::array& P, const af::array& mu, const af::array& Sigma);
	void weights_from_pdfs(af::array& weights, const af::array& pdfs);
	void classwise_share(af::array& shares, const af::array &weights, float scalar=1.0);
	void mstep(af::array& P, af::array& mu, af::array& Sigma, const af::array& samples, const af::array& weights, af::array& FSC_A, af::array& FSC_B, const af::array& ones, const af::array& fallback_covariance);
	void score(af::array& scores, const af::array& mu, const af::array& Sigma, const af::array& samples, const af::array& weights);
	void determine_least_fitting_class(unsigned *hout_iworst_score, float *hout_worst_score, const af::array& scores);
	void split_class(af::array& nP, af::array& nmu, af::array& nSigma, const af::array& P, const af::array& mu, const af::array& Sigma, unsigned iscore, float score);
	float log_likelihood(const af::array& pdfs);
};
