# The Clustering Benchmark described in Section 4.3
A terrain clustering benchmark based on the Mixture of Gaussian algorithm.

## Implementations
* ArrayFire CUDA: `worker_af_cuda`
* ArrayFire Python: `worker_af.py`
* CUDA: `worker_static`
* MATLAB: `worker_matlab.sh`
* MATLAB (CPU 16 cores): `worker_matlab_cpu.sh`
* CUDA cuBLAS: `worker_static_cublas`
* CUDA RAII: `worker_dynamic`
* ArrayFire Score: `worker_af_cuda_oscore`
* ArrayFire MoGEM: `worker_af_cuda_omogem`

## Running benchmarks
`./$WORKER <CMX>...` 

Where `$WORKER` is the implementation and `<CMX>...` are extracted features as
.cmf32 files that all have the same number of samples. The experiments used
extracted features from the cuda implementation of the streaming pipeline
benchmark. `cmx_transform -c 2000x1500+6000+6000 *log*19431x25289` was used for
the cropping procedure.

## Dependencies
* CUDA Toolkit v7.5
* ArrayFire v3.3.1 (CUDA, 64-bit Linux, build f53efc3)
* MATLAB 2015b (only `worker_matlab*`)
* Python 3.4.1 (only `worker_af.py`)
	* scipy 0.16.0
	* arrayfire 3.3.20160328
