#!/bin/gawk -f
BEGIN {
	Body=0
	EndPattern = "DO NOT MATCH THIS"
	ClassAggregator = 0
	WorkloadEstimateAggregator = 0
	SingularAggregator = 0
}

!Body && match($0, /\(\(i=0;i<([0-9]+);i\+\+\)\)/, m) {NITERATION = m[1]}
/^---BENCHMARK BEGIN---$/ {Body=1}
/^---BENCHMARK END---$/ {Body=0}

Body && $2~/SPLIT/ {ClassAggregator+=1; WorkloadEstimateAggregator += $12*ClassAggregator;}
Body && $2~/SINGULAR/ {SingularAggregator += 1}
Body && $2~/AMOG/ {
	benchmark = $1
	duration = $4-$3

	N[benchmark] += 1
	delta = duration - u[benchmark]
	u[benchmark] += delta/N[benchmark]
	SSM[benchmark] += delta * (duration-u[benchmark])
	if (N[benchmark] == 1) {
		WorkloadEstimate[benchmark] = WorkloadEstimateAggregator
		NClass[benchmark] = ClassAggregator
		NSingularRandomizations[benchmark] = SingularAggregator

		min[benchmark] = duration
		max[benchmark] = duration
	} else if (duration < min[benchmark]) {
		min[benchmark] = duration
	} else if (duration > max[benchmark]) {
		max[benchmark] = duration;
	}

	ClassAggregator = 0
	WorkloadEstimateAggregator = 0
	SingularAggregator = 0
}

END {
	for (benchmark in N) {
		stderr = sqrt(SSM[benchmark]/N[benchmark]) / N[benchmark]
		print benchmark, u[benchmark], stderr, min[benchmark], max[benchmark], WorkloadEstimate[benchmark], NClass[benchmark], NSingularRandomizations[benchmark]
	}
}
