#!/bin/bash -

mydir="$(dirname "$0")"
[ "$AGGREGATOR" ] || AGGREGATOR="$mydir/aggregate_benchmark_output.gawk"

for f in $@; do
	dir="$(dirname "$f")/"
	IFS="_" read -a fntokens <<< "$(basename "${f%.*}")"
	datetime="${fntokens[0]}_${fntokens[1]}"

	declare -A params;
	for kv in "${fntokens[@]:3}"; do
		params[${kv%=*}]="${kv#*=}"
	done

	[ "$PREFIX" ] && dir="$PREFIX"
	prefix="$dir${datetime}_"
	declare -A truncated
	while read l; do
		bm="${l%% *}"
		data="${l#* }"
		output="$prefix$bm"
		if [ -z "${truncated[$output]}" ]; then
			> "$output"
			truncated[${output}]=$output
		fi

		echo ${params[SUBSAMPLE]} "$data" >> "$output"
	done < <("$AGGREGATOR" < "$f")

done
for of in "${truncated[@]}"; do
	sort -no "$of" "$of"
done
