#pragma once

#include <cassert>
#include <iostream>

#include <arrayfire.h>
#include <af/cuda.h>
#include "common.cuh"

static inline dim3 dim3_from_af_dim4(const af::dim4& dims) {
	assert(dims[3] == 1);
	return dim3(dims[0],dims[1],dims[2]);
}

template <typename... Args> static inline void af_cuda_launch(void (*kernel)(dim3, Args...), const af::dim4& problem, dim3 threads, Args... args) {
	cudaStream_t af_stream = afcu::getStream(af::getDevice());

	dim3 dproblem = dim3_from_af_dim4(problem);
	kernel<<<gs(dproblem,threads), threads, 0, af_stream>>>(dproblem, args...);
}
template <typename... Args> static inline void af_cuda_launch(void (*kernel)(dim3, Args...), const af::dim4& problem, Args... args) {
	dim3 threads = problem[1]==1 && problem[2]==1 && problem[3]==1 ? BS_1D : BS_2D;
	af_cuda_launch(kernel, problem, threads, args...);
}
