#!/bin/awk -f
BEGIN{
	FirstSample=1
	SI["n"] = 1e-9
	SI["u"] = 1e-6
	SI["m"] = 1e-3
	SI["K"] = 1e3
	SI["k"] = 1e3
	SI["M"] = 1e6
	SI["G"] = 1e9
	SI["s"] = 1
	SI["B"] = 1
}
NextIsSample && /^$/ {NextIsSample = 0}
NextIsSample {
	if (FirstSample) {
		TFirst = $1
		FirstSample = 0
	} else {
		TLast = $1
	}
}
NextIsUnits {
	SClock = SI[substr($1,1,1)]
	SDuration = SI[substr($2,1,1)]
	SSize = SI[substr($5,1,1)]
	NextIsUnits = 0
	NextIsSample = 1
}
$1 == "Start" && $2 == "Duration" && $3 == "Grid" {NextIsUnits = 1}
match($0, /\[CUDA (memcpy [^\]]+)\]/, m) {
	Count[m[1]] += 1
	Total[m[1]] += $8
	Duration[m[1]] += $2
}
END {
	for (op in Count) {
		print op, Count[op], Total[op]*SSize, Duration[op]*SDuration, (TLast-TFirst)*SClock
	}
}
