#!/usr/bin/env python3
import arrayfire as af

def parse(filenameWithCmxSuffix):
    suffix = filenameWithCmxSuffix.split(".")[-1]
    (cmAndType,dims) = suffix.split("_")
    return (eval("af.Dtype."+cmAndType[2:]), tuple([int(d) for d in dims.split("x")]))


def suffix(dtype, dims):
    return ".cm"+dtype._name_+"_"+"x".join([str(d) for d in dims])


def suffix_from_array(A):
    return suffix(A.dtype(), A.dims())


def write(darray, prefix):
    fn = prefix + suffix_from_array(darray)
    with open(fn, "wb") as f:
        harray = darray.to_array()
        harray.tofile(f)
