function [type, dims, nnumberPerElement, nbytePerElement] = cmxExtract(filename)
	[~,~,fileSuffix] = fileparts(filename);
	assert(strncmp(fileSuffix, '.cm', 3));

	underscores = strfind(fileSuffix, '_');
	assert(numel(underscores) == 1);
	startOfDims = underscores(1);

	af_type = fileSuffix(4:(startOfDims-1));
	dim_suffix = fileSuffix((startOfDims+1):end);

	nnumberPerElement = 1;
	switch af_type(1)
	case 'c'
		type_base='float';
		nnumberPerElement = 2;
	case 'f'
		type_base='float';
	case 's'
		type_base='int';
	case 'u'
		type_base='uint';
	end

	type = [type_base, af_type(2:end)];

	dim_separators = strfind(dim_suffix, 'x');

	dims = [];
	prev = 1;
	for i = dim_separators
		dims(numel(dims)+1) = str2num(dim_suffix(prev:(i-1)));
		prev = (i+1);
	end
	dims(numel(dims)+1) = str2num(dim_suffix(prev:end));

	nbytePerElement = (str2num(af_type(2:end))/8) * nnumberPerElement;
end
