function [A] = cmxRead(filename, nmajorLimit, nmajorSkip)
	[type, dims, nnumberPerElement, nbytePerElement] = cmxExtract(filename);

	fp = fopen(filename, 'r');

	if exist('nmajorSkip','var') && ~isempty(nmajorSkip)
		assert(nmajorSkip < dims(ndims(dims)));
		dimsSkip = dims
		dimsSkip(ndims(dims)) = nmajorSkip;
		fseek(fp, prod(dimsSkip)*nbytePerElement, 'bof');
	end
	if exist('nmajorLimit', 'var') && ~isempty(nmajorLimit)
		assert(nmajorLimit <= dims(ndims(dims)));
		dims(ndims(dims)) = nmajorLimit;
	end

	A = fread(fp, [nnumberPerElement, prod(dims)], type);
	if (nnumberPerElement == 2)
		A = complex(A(1,:), A(2,:));
	end
	A = reshape(A, dims);

	fclose(fp);
end
