#pragma once
#include <cuda_runtime.h>
#include <iostream>

#define CUDA_DIE_UNLESS_SUCCESS(statement) cuda_die_unless_success((cudaError_t)statement, __func__, __FILE__, __LINE__)
static inline void cuda_die_unless_success(cudaError_t status, const char *function, const char *filename, int linenumber) {
	if (status != cudaSuccess) {
		std::cerr << "CUDA Error: "<<function<<"("<<filename<<":"<<linenumber<<"): "<<cudaGetErrorString(status) << std::endl;
		std::exit(1);
	}
}
