#!/usr/bin/env python3
import pycuda.gpuarray as da
import math

def dim3(x=1,y=1,z=1):
    return da.vec.make_uint3(x,y,z)
def gs(p, ts):
    return (math.ceil(p[0]/ts[0]), math.ceil(p[1]/ts[1]), math.ceil(p[2]/ts[2]))

TS_1D = (256,1,1)
TS_2D = (16,16,1)

def ts_warp_aligned(n):
    for i in range(1,6):
        ts = (1<<i) * (1<<i)
        if n <= ts:
            return (ts,1,1)

    return (0,1,1)
