#pragma once

#include <ctime>

namespace monotonic {
	extern struct timespec initial_timestamp;

	void init(clockid_t clk_id=CLOCK_MONOTONIC);
	inline double since(const struct timespec *reference=NULL) {
		if (reference == NULL) {
			reference = &initial_timestamp;
		}
		struct timespec now;
		clock_gettime(CLOCK_MONOTONIC, &now);
		return now.tv_sec-reference->tv_sec + (now.tv_nsec-reference->tv_nsec)/1e9;
	}
};
