#include <cassert>
#include <arrayfire.h>

#include "../af_utils.hpp"

int main(int argc, char *argv[]) {
	af::setBackend(AF_BACKEND_CPU); // lots of RAM
	assert(argc >= 3);

	af::array A = af_utils::load_cmx(argv[1]);
	af::array B = af_utils::load_cmx(argv[2]);

	assert(A.type() == B.type());
	assert(A.dims() == B.dims());

	af::array compare = A-B;
	if (argc >= 4) {
		char *parsed_valid_integer;
		unsigned padding_to_ignore = strtoul(argv[3], &parsed_valid_integer, 0);
		assert(parsed_valid_integer != NULL);

		af::seq cropper[4] = {af::span};
		for (int i=0; i<4; i++) {
			if (compare.dims(i) != 1) {
				assert(compare.dims(i) > 2*padding_to_ignore);
				cropper[i] = af::seq(padding_to_ignore, compare.dims(i)-padding_to_ignore-1);
			}
		}
		compare = compare(cropper[0], cropper[1], cropper[2], cropper[3]);
	}

	af_utils::dump_info(std::cout, compare, "A-B");

	return 0;
}
