#!/usr/bin/env python3
from os import path
from sys import argv, stdin

varname = argv[1]

tokens = varname.split("::")
array = tokens[-1]
namespaces = tokens[:-1]

print("#pragma once")
for i in range(len(namespaces)):
    print("%snamespace %s {"%("\t"*i, namespaces[i]))

print("%sconst char %s[] = {"%("\t"*len(namespaces), array))
while not stdin.closed:
    chunk = stdin.buffer.read(16)
    Bs = ["0x%02x"%(byte) for byte in chunk]
    print("\t"*(len(namespaces)+1) + ",".join(Bs) + ",")
    if len(chunk) < 16:
        break

print("\t"*len(namespaces) + "};")
for i in range(len(namespaces)-1, -1, -1):
    print("\t"*i + "}")
