#!/bin/bash -
me=`basename "$0"`
mydir=`dirname "$0"`

NPOLARIZATION=2

matlab_string_list() {
	fns="{"
	prefix_comma=
	for fn in "$@"; do
		[ "$prefix_comma" ] && fns+=", "
		fns+="'$fn'"
		prefix_comma=1
	done
	fns+="}"
	echo "$fns"
}

kill_children() {
	kill `jobs -p`
}
trap kill_children INT TERM

output_prefix=""
while getopts o: o
do	case "$o" in
	o)	output_prefix="$OPTARG";;
	[?])	print >&2 "Usage: $0 [-o OUTPUT_PREFIX] POLARIZATION..."
		exit 1;;
	esac
done
shift $((OPTIND-1))

polarization_fns="$(matlab_string_list "${@}")"

matlab -nodesktop -nosplash -r "userpath('$(readlink -f common)');sli_features($polarization_fns, '$output_prefix'); quit force" | grep '^STDOUT ' | cut -d ' ' -f 2- &
wait
