# Functionality common to both Clustering and Streaming Pipeline implementations

## Content
* `aggregate_memory_trace.awk`: script to aggregate the memory transfer operation from `nvprof` GPU traces
* `run_all_parameterized.rb`: tools used to run benchmarks for every permutation of its given arguments
* `cmx*`, `af_utils::*cmx*`: tools for dealing with intermediate files of type `.cmX_D1[xD2[,...]]`, which contain raw column-major array data of ArrayFire type X with dimensions D1 through DN.
* `af_utils`: miscellaneous ArrayFire utilities
* `*.cuh`: miscellaneous CUDA utilities
* `tools/*`: binaries for various tasks, mostly dealing with cmX-files
* `monotonic`, `cuda_timer.cuh`: timers
* `column_major_2d_submatrix_iterator.cuh`: a proof-of-concept matrix wrapper for Thrust iterators

## Dependencies
* CUDA Toolkit v7.5
* ArrayFire v3.3.1 (CUDA, 64-bit Linux, build f53efc3)
* libgeotiff v2.1.1 (only `af_geotiff`)
